=== debian/changelog ===
ros-melodic-nerian-stereo (3.11.0-1bionic) bionic; urgency=high

  * Added log messages about actively served topics (based on run-time conf)
  * Added support for auto color from third Ruby camera (if enabled)
  * Better conformity with new parameter types
  * Initiate image tranfer despite any failure to connect to parameter server
    (No dynamic parameters will be available; a verbose error is logged.)
  * Contributors: Dr. Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 10 Jan 2023 23:00:00 -0000

ros-melodic-nerian-stereo (3.10.0-1bionic) bionic; urgency=high

  * Updated vision softare release to version 10.0.0
  * Disable Open3D in libvisiontransfer builds
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 29 Jun 2022 22:00:00 -0000

ros-melodic-nerian-stereo (3.9.1-1bionic) bionic; urgency=high

  * Updated vision software release
  * Fixed point cloud color channel issue with large RGB images
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 28 Feb 2022 23:00:00 -0000

ros-melodic-nerian-stereo (3.9.0-1bionic) bionic; urgency=high

  * ROS transform (tf2) live updates for Nerian devices with IMU
  * Added script for splitting camera info
  * Updated vision software release
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 13 Apr 2021 22:00:00 -0000

ros-melodic-nerian-stereo (3.8.1-1bionic) bionic; urgency=high

  * Build fix for Ubuntu 20.04
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 29 Jul 2020 22:00:00 -0000

ros-melodic-nerian-stereo (3.8.0-1bionic) bionic; urgency=high

  * Updated to nerian software release version 8.1.0
  * Support for 1 to 3 images in result set
  * Added new device configuration variables
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 28 Jul 2020 22:00:00 -0000

ros-melodic-nerian-stereo (3.7.0-1bionic) bionic; urgency=high

  * Added new trigger configuration parameters
  * Updated to vision software release 7.2
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 20 Feb 2020 23:00:00 -0000

ros-melodic-nerian-stereo (3.6.0-1bionic) bionic; urgency=high

  * Updated Nerian software release to version 7.1.0
  * Correct pixel format for publication of RGB camera images
  * Fixed problem with LD_LIBRARY_PATH when running from catkin workspace
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 04 Dec 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.5.0-1bionic) bionic; urgency=high

  * Updated to libvisiontransfer 7.0.0
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 14 Aug 2019 22:00:00 -0000

ros-melodic-nerian-stereo (3.4.0-1bionic) bionic; urgency=high

  * Updated to latest Nerian software release 6.5.0
  * New nodelet version of ROS module
  * Support for dynamic_reconfigure
  * Corrected marking of point clouds as not dense

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 18 Jun 2019 22:00:00 -0000

ros-melodic-nerian-stereo (3.3.2-1bionic) bionic; urgency=high

  * Fixed installation permissions
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 14 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.3.1-1bionic) bionic; urgency=high

  * Compile fix for older Ubuntu versions

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Thu, 07 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.3.0-1bionic) bionic; urgency=high

  * Updated to Nerian vision software release 6.4.0
  * Added functionality to use timestamps from SceneScan for timestamping transmitted messages.
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sun, 03 Feb 2019 23:00:00 -0000

ros-melodic-nerian-stereo (3.2.1-1bionic) bionic; urgency=high

  * Updated Nerian vision software to version 6.2.1
  * Added curl dependency to package.xml
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.2.0-1bionic) bionic; urgency=high

  * Added support for colored point clouds
  * Automated detection of libvisiontransfer version
  * Updated nerian vision software to 6.2.0
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 26 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.1.1-1bionic) bionic; urgency=high

  * Fixed CMake build problem
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 12 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.1.0-1bionic) bionic; urgency=high

  * Removed arch=native flag from compiler options
  * Updated nerian vision software to 6.1.1
  * Added support for combined RGB color channel in pointcloud
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Fri, 09 Nov 2018 23:00:00 -0000

ros-melodic-nerian-stereo (3.0.2-1bionic) bionic; urgency=high

  * Fixed build errors

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 06 Aug 2018 22:00:00 -0000

ros-melodic-nerian-stereo (3.0.1-1bionic) bionic; urgency=high

  * Installing missing scripts for binary release
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Sun, 05 Aug 2018 22:00:00 -0000

ros-melodic-nerian-stereo (3.0.0-1bionic) bionic; urgency=high


